exec("./weapon_akimbocolt.cs");
exec("./support_Spacecasts.cs");
datablock AudioProfile(coltshotSound)
{
   filename    = "./colt.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(coltreloadSound)
{
   filename    = "./colt_worldreload.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(dryfireSound)
{
   filename    = "./noammo.wav";
   description = AudioClose3d;
   preload = true;
};




if($ammo::default["colt"]$="")$ammo::default["colt"]=15;

datablock DebrisData(coltShellDebris)
{
	shapeFile = "add-ons/weapon_gun/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
datablock ParticleData(coltSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   textureName          = "./spark00";
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "1.0 0.36 0.26 0.0";
   sizes[0]      = 0.6;
   sizes[1]      = 0.2;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(coltSparkEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 100;
   particles = "coltSparks";
};


//muzzle flash effects
datablock ParticleData(coltFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(coltFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "coltFlashParticle";


};

datablock ParticleData(coltExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 150;
   textureName          = "./smoke";

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(coltExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "coltExplosionParticle";
};
datablock ParticleData(coltImpactSmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "./particleTest";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(coltImpactSmoke)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "coltImpactSmokeParticle";
   lifetimeMS       = 50;
};


datablock ExplosionData(coltExplosion)
{
	soundProfile = bulletHitSound;


   //emitter[0] = coltImpactSmoke;
   emitter[0] = coltSparkEmitter;
   emitter[1] = coltImpactSmoke;
   faceViewer           = false;
};




datablock ProjectileData(coltProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::colt;
   radiusDamageType    = $DamageType::colt;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 500;
   verticalImpulse	  = 0;
   explosion           = coltExplosion;
   particleEmitter     = gunTrailEmitter;

   muzzleVelocity      = 1000;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};


//////////
// item //
//////////
datablock ItemData(coltItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./colt3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Colt 1911";
	iconName = "./colt";
	doColorShift = false;
	colorShiftColor = "0.6 0.6 0.6 1.000";

	 // Dynamic properties defined by the scripts
	image = coltImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(coltImage)
{

   // Basic Item properties
   shapeFile = "./colt3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = coltProjectile;
   projectileType = Projectile;

	casing = coltShellDebris;
	shellExitDir        = "1.0 -1.3 2.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.6 0.6 0.6 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.0;
	stateSequence[0]                = "activate";
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[1]                     = "Ready";
	stateSequence[1]	= "Ready";
	statescript[1]="checkammo";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= coltFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= coltshotSound;
	stateEjectShell[2]       = true;
	//---------LINE OF SEPERATION :/-------------------------------
	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	statetransitionOnNoAmmo[3]      = "reload";
	stateTransitionOnTimeout[3]     = "checkfire";
	//---------LINE OF SEPERATION :/-------------------------------	
	stateName[4]			= "checkfire";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
	//---------LINE OF SEPERATION :/-------------------------------	
	stateName[5]			= "checkclick";
	stateWaitForTimeout[5]			= false;
	stateTimeoutValue[5]            = 0.3;
		stateSequence[5]	= "noammo";
	stateTransitionOnTriggerdown[5]     = "dryfire";
	stateTransitionOntimeout[5]     = "reload";
	stateSequence[5]	= "noammo";
		//---------LINE OF SEPERATION :/-------------------------------
	stateName[6]			= "dryfire";
	stateWaitForTimeout[6]			= true;
	stateTimeoutValue[6]            = 0.05;
		stateSequence[6]	= "noammo";
	stateSound[6]					= dryfireSound;
	stateTransitionOnTriggerup[6]     = "checkclick";
	stateSequence[6]	= "noammo";
	
	stateName[7]			= "reload";
	//stateSequence[5]                = "Reload";
	stateAllowImageChange[7]        = true;
	stateWaitForTimeout[7]			= true;
	stateTimeoutValue[7]            = 1.5;

	stateSequence[7]	= "noammo";
	statescript[7]            = "onreload";
	stateSound[7]					= coltreloadSound;
	stateTransitionOnTimeout[7]     = "ready";

};
function ColtImage::onfire(%this,%obj,%slot)
{
	%player = %obj;
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["colt"]@"/15");
    if(!%obj.ammo["colt"]){%obj.setimageammo(%slot,0);
	return;
	}
	if(vectorLen(%player.getVelocity()) <= 0.1)
	{
	    %obj.setimageammo(%slot,1);
		%obj.ammo["colt"]-=1;
	
		%projectile = coltprojectile;
		%spread = 0.001;
		%shellcount = 1;
	



		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		}
		else//---------------------------------------------if player moves
		{
		%obj.setimageammo(%slot,1);
		%obj.ammo["colt"]-=1;
	
		%projectile = coltprojectile;
		%spread = 0.02;
		%shellcount = 1;
	



			for(%shell=0; %shell<%shellcount; %shell++)
			{
				%vector = %obj.getMuzzleVector(%slot);
				%objectVelocity = %obj.getVelocity();
				%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
				%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
				%velocity = VectorAdd(%vector1,%vector2);
				%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
	}
	return %p;

}
function coltImage::onreload(%this, %obj, %slot)
{
    if(%obj.ammo["colt"]$=0)
	%obj.ammo["colt"]=15;
    if(%obj.ammount$="")
	%obj.ammount=0;
	    %obj.ammo["colt"]+=%obj.ammount;
		echo("reload?");
		    centerPrint(%obj.client, "<just:right>0/15");
}
function ColtImage::checkammo(%this,%obj,%slot)
{
    if(%obj.ammo["colt"]$="")%obj.ammo["colt"]=$ammo::default["colt"];
    if(%obj.ammo["colt"])%obj.setimageammo(%slot,1);
    centerPrint(%obj.client, "<just:right>"@%obj.ammo["colt"]@"/15");
}



//exec("add-ons/weapon_colt/server.cs");
